import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A 'Body' is any kind of object in space that has a mass. It could be a star, or a planet, 
 * or anything else that floats around in space.
 * 
 * @author Michael Kolling 
 * @version 0.1
 */
public class Rocket extends SmoothMover
{   
    public Rocket() {
        this(new Vector(0, 15.0));
    }
    
    /**
     * Construct a Rocket with a specified movement.
     */
    public Rocket(Vector movement)
    {
        addForce(movement);
    }
    
    /**
     * Act. That is: move.
     */
    public void act() 
    {
        move();
        checkForEdges();
        checkForBarrels();
        randomTurn();
    }
    
    private void randomTurn() {
        if(Greenfoot.getRandomNumber(100) < 10) {
            setRotation(getRotation()-10);
            Vector v = getMovement();
            v.setDirection(getRotation());
        }
    }
    
    private void checkForEdges() {
        if(getX() < 30 || getX() > getWorld().getWidth() - 30) {
            setRotation(getRotation()+15);
            Vector v = getMovement();
            v.setDirection(getRotation());
            move();
        }
        if(getY() < 30 || getY() > getWorld().getHeight() - 30) {
            setRotation(getRotation()+15);
            Vector v = getMovement();
            v.setDirection(getRotation());
            move();
        }
    }
    
    private void checkForBarrels() {
        if(getOneIntersectingObject(Barrel.class) != null) {
            setRotation(getRotation()+45);
            Vector v = getMovement();
            v.setDirection(getRotation());
            move();
        }
    }
}
